package com.agiledeveloper.archchecks;

import com.tngtech.archunit.core.domain.JavaClasses;
import com.tngtech.archunit.core.importer.ClassFileImporter;
import com.tngtech.archunit.junit.AnalyzeClasses;
import org.junit.jupiter.api.Test;

import static com.tngtech.archunit.library.dependencies.SlicesRuleDefinition.slices;

@AnalyzeClasses
public class CheckCycles {
  private JavaClasses classes = new ClassFileImporter().importPackages("com.agiledeveloper.vehicles", "com.agiledeveloper.engines");

  @Test
  void noCyclesBetweenModules() {
    slices()
      .matching("com.agiledeveloper.(*)..")
      .should()
      .beFreeOfCycles()
      .check(classes);
  }
}
