package com.agiledeveloper.archchecks;

import com.tngtech.archunit.core.domain.JavaClasses;
import com.tngtech.archunit.core.importer.ClassFileImporter;
import com.tngtech.archunit.junit.AnalyzeClasses;
import org.junit.jupiter.api.Test;

import static com.tngtech.archunit.lang.syntax.ArchRuleDefinition.classes;

@AnalyzeClasses
public class LayersCheck {
  private JavaClasses classes = new ClassFileImporter().importPackages(
    "com.agiledeveloper.accounts.controller",
    "com.agiledeveloper.accounts.service",
    "com.agiledeveloper.accounts.repository",
    "com.agiledeveloper.accounts.entity"
  );

  @Test
  void checkRepositoryIsUsedOnlyByService(){
    classes()
      .that()
      .resideInAPackage("com.agiledeveloper.accounts.repository")
      .should()
      .onlyBeAccessed()
      .byAnyPackage("..service..", "..repository..")
      .check(classes);
  }

  @Test
  void checkServiceIsUsedOnlyByController(){
    classes()
      .that()
      .resideInAPackage("com.agiledeveloper.accounts.service")
      .should()
      .onlyBeAccessed()
      .byAnyPackage("..controller..", "..service..")
      .check(classes);
  }
}
